' ---------------------------------------------------------------------------------------
'
' Deckblatt.VB                                                     Ulrich Mller 30.09.02
'                                                                  PCS1700   VB.NET Final
' Solitr.NET : Wahl der Kartenrckseite
'               Bei Paint werden die sechs Mglichen gezeichnet, der aktuelle wird durch
'               einen Rahmen gekennzeichnet. Bei MouseDown wird der neue bestimmt.
'               Die BackNr wird ber gp As GlobaleDaten gehandhabt.
'
' ---------------------------------------------------------------------------------------
Public Class Deckblatt
  Inherits System.Windows.Forms.Form

  Private gp As GlobaleDaten
  Private BackNr = gp.BackNr
  Private Declare Sub DrawBackQC Lib "qcard32.dll" Alias "DrawBack" _
    (ByVal hwnd As IntPtr, ByVal nValue%, ByVal x%, ByVal y%)

#Region " Vom Windows Form Designer generierter Code "

  Public Sub New(ByVal gp As GlobaleDaten)
    MyBase.New()

    ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
    InitializeComponent()

    ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
    Me.gp = gp

  End Sub

  ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Fr Windows Form-Designer erforderlich
  Private components As System.ComponentModel.IContainer

  'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
  'Sie kann mit dem Windows Form-Designer modifiziert werden.
  'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents cmdOK As System.Windows.Forms.Button
  Friend WithEvents cmdAbbruch As System.Windows.Forms.Button
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Deckblatt))
    Me.cmdOK = New System.Windows.Forms.Button()
    Me.cmdAbbruch = New System.Windows.Forms.Button()
    Me.SuspendLayout()
    '
    'cmdOK
    '
    Me.cmdOK.Location = New System.Drawing.Point(16, 232)
    Me.cmdOK.Name = "cmdOK"
    Me.cmdOK.Size = New System.Drawing.Size(96, 24)
    Me.cmdOK.TabIndex = 1
    Me.cmdOK.Text = "&OK"
    '
    'cmdAbbruch
    '
    Me.cmdAbbruch.DialogResult = System.Windows.Forms.DialogResult.Cancel
    Me.cmdAbbruch.Location = New System.Drawing.Point(176, 232)
    Me.cmdAbbruch.Name = "cmdAbbruch"
    Me.cmdAbbruch.Size = New System.Drawing.Size(96, 24)
    Me.cmdAbbruch.TabIndex = 2
    Me.cmdAbbruch.Text = "&Abbrechen"
    '
    'Deckblatt
    '
    Me.AcceptButton = Me.cmdOK
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.CancelButton = Me.cmdAbbruch
    Me.ClientSize = New System.Drawing.Size(292, 273)
    Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.cmdAbbruch, Me.cmdOK})
    Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
    Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
    Me.MaximizeBox = False
    Me.Name = "Deckblatt"
    Me.ShowInTaskbar = False
    Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
    Me.Text = "Solitr.NET : Optionen - Deckblatt"
    Me.ResumeLayout(False)

  End Sub

#End Region


  ' Deckblatt_Paint -------------------------------------------------------------------
  '                 Zeichnen der mgliche Deckbltter mit QCard32.DrawBack auf Handle
  '                 der Form. Zeichnen Rahmen um aktuelle Karte mit GDI+
  ' -----------------------------------------------------------------------------------
  Private Sub Deckblatt_Paint(ByVal sender As Object, _
                    ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
    Dim i%, j%
    For i = 0 To 2
      For j = 0 To 1
        DrawBackQC(Me.Handle, (i + 1) + (3 * j), i * 80 + 28, j * 104 + 12)
      Next j
    Next i
    e.Graphics.DrawRectangle(New Pen(Color.Fuchsia, 5), Koor(BackNr))
  End Sub

  ' Deckblatt_MouseDown ----------------------------------------------------------------
  '                     Bestimmen auf welche Karte die Maus zeigt und Rahmen um gewhlte
  '                     Karte. Halten der gewhlten Karte in BackNr
  ' ------------------------------------------------------------------------------------
  Private Sub Deckblatt_MouseDown(ByVal sender As Object, _
                ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
    Dim i%, j%
    Dim gr As Graphics = Me.CreateGraphics
    gr.DrawRectangle(New Pen(Me.BackColor, 5), Koor(BackNr))
    BackNr = 1
    If e.Y > 120 Then BackNr += 3
    If e.X > 110 Then BackNr += 1
    If e.X > 190 Then BackNr += 1
    gr.DrawRectangle(New Pen(Color.Fuchsia, 5), Koor(BackNr))
    gr.Dispose()
  End Sub

  ' cmdOK_Click ------------------------------------------------------------------------
  '             BackNr in globale Daten. cmdAbbrechen ist als Default/Esc deklariert
  ' ------------------------------------------------------------------------------------
  Private Sub cmdOK_Click(ByVal sender As Object, _
                                        ByVal e As System.EventArgs) Handles cmdOK.Click
    gp.BackNr = BackNr
    Me.Close()
  End Sub

  ' Koor ------------------------------------------------------------------------------
  '      PixelKoordinaten auf Form anhand BackNr ( 1, 2, 3 | 4, 5, 6)
  ' -----------------------------------------------------------------------------------
  Private Function Koor(ByVal n%) As Rectangle
    Dim i% = BackNr - 1
    Dim j% = 0
    If BackNr > 3 Then
      i -= 3
      j = 1
    End If
    Return New Rectangle(i * 80 + 28, j * 104 + 12, 73, 97)
  End Function

End Class
